<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
    <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.7.0/jquery.min.js"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
    <title>List Users</title>
</head>

<body>
    <div class="container">
        <h2 class="text-center my-4">Danh sách người dùng đăng ký</h2>
        <table id="table-users" class="table table-striped table-bordered table-hover">
            <thead>
                <tr>
                    <th scope="col">ID</th>
                    <th scope="col">Firstname</th>
                    <th scope="col">Lastname</th>
                    <th scope="col">Country</th>
                    <th scope="col">Subject</th>
                    <th scope="col">Customer Type</th>
                    <th scope="col">Register Status</th>
                    <th scope="col">Action</th>
                </tr>
            </thead>
            <tbody>

            </tbody>
        </table>
    </div>
</body>
<script>
    /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
    const gREQUEST_STATUS_OK = 200;
    const gREQUEST_READY_STATUS_FINISH_AND_OK = 4;

    /*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */
    $(document).ready(function(){
        onPageLoading();
        $("#table-users").on("click", ".btn-sua", function(){
            onBtnSuaClick(this);
        });
        $("#table-users").on("click", ".btn-xoa", function(){
            onBtnXoaClick(this);
        });
    });
    /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */  
    function onPageLoading(){ 
        // Khi tải trang, gọi API để lấy danh sách Users (xem API mẫu)ghi được Response ra console
        getAllUsers();
    }
    // Hàm xử lý sự kiện khi bấm nút Xóa
    function onBtnXoaClick(paramElement){
        var userId = $(paramElement).data("userid");
        console.log (userId);
    }
    // Hàm xử lý sự kiện khi bấm nút Sửa
    function onBtnSuaClick(paramElement){
        var userId = $(paramElement).data("userid");
        console.log (userId);
    }
    /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
    // Hàm lấy all users;
    function getAllUsers() {
        //base url
        const vBASE_URL = "http://203.171.20.210:8080/crud-api/users/";
        // create a request
        var vXmlHttObj = new XMLHttpRequest();
        vXmlHttObj.open("GET", vBASE_URL, true);
        vXmlHttObj.send();
        vXmlHttObj.onreadystatechange = function () {
            if (this.readyState == gREQUEST_READY_STATUS_FINISH_AND_OK && this.status == gREQUEST_STATUS_OK) {
                // Xử lý hiển thị
                //console.log(vXmlHttObj.responseText);
                loadUsersIntoTable(vXmlHttObj.responseText);
            }
        }

    }
    // Hàm đọc danh sách user và đưa vào bảng
    function loadUsersIntoTable(paramResponseText){
        var vUsersObject = JSON.parse (paramResponseText);
        console.log (vUsersObject);
        var vTable = $("#table-users");
        //
        for (var bIndex = 0; bIndex < vUsersObject.length; bIndex++){
            var vTrTag = $("<tr>").appendTo (vTable);
            $("<td>", {html: vUsersObject[bIndex].id}).appendTo(vTrTag);
            $("<td>", {html: vUsersObject[bIndex].firstname}).appendTo(vTrTag);
            $("<td>", {html: vUsersObject[bIndex].lastname}).appendTo(vTrTag);
            $("<td>", {html: vUsersObject[bIndex].country}).appendTo(vTrTag);
            $("<td>", {html: vUsersObject[bIndex].subject}).appendTo(vTrTag);
            $("<td>", {html: vUsersObject[bIndex].customerType}).appendTo(vTrTag);
            $("<td>", {html: vUsersObject[bIndex].registerStatus}).appendTo(vTrTag);
            var vActionCell = $("<td>").appendTo(vTrTag);
            $("<button>", {
                html: "Sửa",
                class: "btn btn-primary mr-2 btn-sua"

            })
            .data("userid", vUsersObject[bIndex].id)
            .appendTo (vActionCell);
            $("<button>", {
                html: "Xóa",
                class: "btn btn-danger btn-xoa"
            })
            .data("userid", vUsersObject[bIndex].id)
            .appendTo (vActionCell);        
        }

    }
</script>
</html>
